
//ws2_32.h :



#ifndef H_ws2_32_H
#define H_ws2_32_H 1

typedef int(*APIWRAPPER)(void);

#ifdef __cplusplus
extern "C" {
#endif

extern APIWRAPPER p_accept;
extern APIWRAPPER p_bind;
extern APIWRAPPER p_closesocket;
extern APIWRAPPER p_connect;
extern APIWRAPPER p_getpeername;
extern APIWRAPPER p_getsockname;
extern APIWRAPPER p_getsockopt;
extern APIWRAPPER p_htonl;
extern APIWRAPPER p_htons;
extern APIWRAPPER p_ioctlsocket;
extern APIWRAPPER p_inet_addr;
extern APIWRAPPER p_inet_ntoa;
extern APIWRAPPER p_listen;
extern APIWRAPPER p_ntohl;
extern APIWRAPPER p_ntohs;
extern APIWRAPPER p_recv;
extern APIWRAPPER p_recvfrom;
extern APIWRAPPER p_select;
extern APIWRAPPER p_send;
extern APIWRAPPER p_sendto;
extern APIWRAPPER p_setsockopt;
extern APIWRAPPER p_shutdown;
extern APIWRAPPER p_socket;
extern APIWRAPPER p_GetAddrInfoW;
extern APIWRAPPER p_GetNameInfoW;
extern APIWRAPPER p_WSApSetPostRoutine;
extern APIWRAPPER p_FreeAddrInfoW;
extern APIWRAPPER p_WPUCompleteOverlappedRequest;
extern APIWRAPPER p_WSAAccept;
extern APIWRAPPER p_WSAAddressToStringA;
extern APIWRAPPER p_WSAAddressToStringW;
extern APIWRAPPER p_WSACloseEvent;
extern APIWRAPPER p_WSAConnect;
extern APIWRAPPER p_WSACreateEvent;
extern APIWRAPPER p_WSADuplicateSocketA;
extern APIWRAPPER p_WSADuplicateSocketW;
extern APIWRAPPER p_WSAEnumNameSpaceProvidersA;
extern APIWRAPPER p_WSAEnumNameSpaceProvidersW;
extern APIWRAPPER p_WSAEnumNetworkEvents;
extern APIWRAPPER p_WSAEnumProtocolsA;
extern APIWRAPPER p_WSAEnumProtocolsW;
extern APIWRAPPER p_WSAEventSelect;
extern APIWRAPPER p_WSAGetOverlappedResult;
extern APIWRAPPER p_WSAGetQOSByName;
extern APIWRAPPER p_WSAGetServiceClassInfoA;
extern APIWRAPPER p_WSAGetServiceClassInfoW;
extern APIWRAPPER p_WSAGetServiceClassNameByClassIdA;
extern APIWRAPPER p_WSAGetServiceClassNameByClassIdW;
extern APIWRAPPER p_WSAHtonl;
extern APIWRAPPER p_WSAHtons;
extern APIWRAPPER p_gethostbyaddr;
extern APIWRAPPER p_gethostbyname;
extern APIWRAPPER p_getprotobyname;
extern APIWRAPPER p_getprotobynumber;
extern APIWRAPPER p_getservbyname;
extern APIWRAPPER p_getservbyport;
extern APIWRAPPER p_gethostname;
extern APIWRAPPER p_WSAInstallServiceClassA;
extern APIWRAPPER p_WSAInstallServiceClassW;
extern APIWRAPPER p_WSAIoctl;
extern APIWRAPPER p_WSAJoinLeaf;
extern APIWRAPPER p_WSALookupServiceBeginA;
extern APIWRAPPER p_WSALookupServiceBeginW;
extern APIWRAPPER p_WSALookupServiceEnd;
extern APIWRAPPER p_WSALookupServiceNextA;
extern APIWRAPPER p_WSALookupServiceNextW;
extern APIWRAPPER p_WSANSPIoctl;
extern APIWRAPPER p_WSANtohl;
extern APIWRAPPER p_WSANtohs;
extern APIWRAPPER p_WSAProviderConfigChange;
extern APIWRAPPER p_WSARecv;
extern APIWRAPPER p_WSARecvDisconnect;
extern APIWRAPPER p_WSARecvFrom;
extern APIWRAPPER p_WSARemoveServiceClass;
extern APIWRAPPER p_WSAResetEvent;
extern APIWRAPPER p_WSASend;
extern APIWRAPPER p_WSASendDisconnect;
extern APIWRAPPER p_WSASendTo;
extern APIWRAPPER p_WSASetEvent;
extern APIWRAPPER p_WSASetServiceA;
extern APIWRAPPER p_WSASetServiceW;
extern APIWRAPPER p_WSASocketA;
extern APIWRAPPER p_WSASocketW;
extern APIWRAPPER p_WSAStringToAddressA;
extern APIWRAPPER p_WSAStringToAddressW;
extern APIWRAPPER p_WSAWaitForMultipleEvents;
extern APIWRAPPER p_WSCDeinstallProvider;
extern APIWRAPPER p_WSCEnableNSProvider;
extern APIWRAPPER p_WSCEnumProtocols;
extern APIWRAPPER p_WSCGetProviderPath;
extern APIWRAPPER p_WSCInstallNameSpace;
extern APIWRAPPER p_WSCInstallProvider;
extern APIWRAPPER p_WSCUnInstallNameSpace;
extern APIWRAPPER p_WSCUpdateProvider;
extern APIWRAPPER p_WSCWriteNameSpaceOrder;
extern APIWRAPPER p_WSCWriteProviderOrder;
extern APIWRAPPER p_freeaddrinfo;
extern APIWRAPPER p_getaddrinfo;
extern APIWRAPPER p_getnameinfo;
extern APIWRAPPER p_WSAAsyncSelect;
extern APIWRAPPER p_WSAAsyncGetHostByAddr;
extern APIWRAPPER p_WSAAsyncGetHostByName;
extern APIWRAPPER p_WSAAsyncGetProtoByNumber;
extern APIWRAPPER p_WSAAsyncGetProtoByName;
extern APIWRAPPER p_WSAAsyncGetServByPort;
extern APIWRAPPER p_WSAAsyncGetServByName;
extern APIWRAPPER p_WSACancelAsyncRequest;
extern APIWRAPPER p_WSASetBlockingHook;
extern APIWRAPPER p_WSAUnhookBlockingHook;
extern APIWRAPPER p_WSAGetLastError;
extern APIWRAPPER p_WSASetLastError;
extern APIWRAPPER p_WSACancelBlockingCall;
extern APIWRAPPER p_WSAIsBlocking;
extern APIWRAPPER p_WSAStartup;
extern APIWRAPPER p_WSACleanup;
extern APIWRAPPER p___WSAFDIsSet;
extern APIWRAPPER p_WEP;

#ifdef __cplusplus
}
#endif

#endif

